<html>
    <head>		
        <link rel="stylesheet" href="css/player.css">
        <link rel="stylesheet" href="css/plyr.css">   
        <link rel="stylesheet" href="css/common.css">   
        <style>
            html, body{
                height:100%;
                overflow: hidden;
            }
        </style>		
    </head>
    <body>

        <!-- CONNEXION -->
        <div class="panel signin">
            <div class="panel-heading">
                <!--<h1><img src="ressources/images/logo.png" alt="logo"></h1>-->
                <h1>D-sound</h1>
                <p>Merci de vous identifier.</p>
            </div>
            <div class="panel-body">

                <form id="loginform" name="loginform">
                    <div class="form-group mb10">
                        <div class="input-group">
                            <input type="text" id="user_name" name="user_name" value="" class="form-control" placeholder="Identifiant">
                        </div>
                    </div>
                    <div class="form-group mb15">
                        <div class="input-group">
                            <input type="password" id="user_password" name="user_password" value="" class="form-control" placeholder="Mot de passe">
                        </div>
                    </div>
                    <div class="form-group">
                        <input type="submit" name="login" class="btn btn-success btn-quirk btn-block" value="Connexion"/>
                        <!--<button id="cleardata" class="btn btn-success btn-quirk btn-block" >Vider les données</button>-->
                    </div>
                    <div>
                        <p class="error-connexion"></p>
                    </div>
                </form>
                <hr class="invisible">
            </div>
        </div><!-- panel -->
        <!-- FIN CONNEXION -->
        
        <!-- LIST PLAYLIST -->
        <div class="box-home" id="list-playlist">
           <div class="panel-heading">
                <h4>Mes Playlists</h4> 
                <div>Fichiers téléchargés : <span id="download-cpt"></span></div>
                <div class="list-playlist-container">

                </div>
                <div class="clear">&nbsp;</div>
           </div>
        </div>
        <!-- FIN LIST PLAYLIST -->

        <!-- PAYER -->
        <div class="player-box">
            <div class="container">
                <div class="column add-bottom">
                    <div id="mainwrap">
                        <div id="nowPlay" style="display:none;">
                                <span class="left" id="npAction">Paused...</span>
                                <span class="right" id="npTitle"></span>
                        </div>
                        <div id="audiowrap">
                                <div id="audio0">
                                    <audio preload id="audio1" controls="controls">Your browser does not support HTML5 Audio!</audio>
                                </div>
                                <div id="tracks">
                                    <a id="btnPrev">&larr;</a>
                                    <a id="btnNext">&rarr;</a>
                                    <div data-plid="0" id="playing-playlist"></div>
                                </div>
                        </div>
                        <div id="plwrap">					
                            <ul id="plList"></ul>
                        </div>
                    </div>
                </div>
            </div>
        </div>	
        <!-- PLAYER MESSAGE -->
        <div class="display-none">
                <audio preload id="audio3" controls="controls" >Your browser does not support HTML5 Audio!</audio>
        </div>
        <!-- FIN PLAYER MESSAGE -->
        <!-- FIN PAYER -->		
        <script>
            const Dexie = require('dexie');
            const {ipcRenderer} = require('electron');
        </script>
        <script src="js/jquery-3.2.1.min.js" onload="window.$ = window.jQuery = module.exports;"></script>	
        <script src="js/html5media.min.js"></script>
        <script src="js/plyr.js"></script>
        <script src="js/player.js"></script>
        <script src="js/playlists.js"></script>
        <script src="js/server.js"></script>

        <script>
            ///webservice/v1/getall

            $(function() {	
                var $playerContainer = $('.player-box');
                var $server = $('html');
                var $playlistsContainer = $('#list-playlist');
                $playlistsContainer.hide();
                $playerContainer.hide();

                function refreshData(userId){
                    setTimeout(function(){
                        $server.data('server').resetCptTracks();
                        getData(parseInt(userId));
                    }, 300000);
                };
                
                
                //met a jour les BDD local et les fichiers en fonction du serveur
                function displayInterface(userId){
                    //$server.data('server').getLocalData();//DEBUG
                    var playlists = $server.data('server').getPlaylists(userId);//Recuperation et affichage des playlists
                    var messages = $server.data('server').getMessages(userId);
                    var diffusions = $server.data('server').getDiffusion(userId);
                    var plannings = $server.data('server').getPlanning(userId);

                    playlists.then(function(playlists){
                        console.log('PLAYLISTS HTML', playlists); 
                        //On recupere les diffusion pour generer les listes de lecture
                        diffusions.then(function(diffusions){
                            $playlistsContainer.data('playlists').displayPlaylists(playlists, diffusions, $playerContainer.data('player'));//Affichage des playlists et gestion de la lecture
                        });

                    });

                    messages.then(function(messages){
                        console.log('MESSAGES HTML', messages);  
                        plannings.then(function(plannings){
                            console.log('PLANNINGS HTML', plannings); 
                            //On lance la vérification toutes les minutes des playlists et messages a jouer
                            if(plannings)$playerContainer.data('player').timerShedulePlay(plannings, messages);

                        });
                    });
                };
                function getData(userId){
                    console.log('REALOAD DATA');
                    $.ajax({
                        url: "http://d-sound.fr",
                        timeout: 10000,
                        error: function(jqXHR) { 
                            if(jqXHR.status==0) {
                                displayInterface(userId);
                            }
                        },
                        success: function() {
                            $server.data('server').getDistantData(userId).then(function(){ 
                                setTimeout(function(){
                                   $server.data('server').downloadTracks(userId);//Téléchargement des titres manquants
                                   console.log('displayInterface');
                                    displayInterface(userId); 
                                }, 5000);
                                
                            });
                        }
                    });
                    
                    refreshData(userId);
                };
                
                
                    
                $playerContainer.player({'plyr':plyr});//Initilisation de l'objet player

                $server.server({ //Initialisation de l'objet server
                    'player':$playerContainer.data('player'), 
                    'playlists':$playlistsContainer.data('playlists')
                }); 

                $playlistsContainer.playlists({//Initialisation de l'objet playlists
                    'player':$playerContainer.data('player')
                });
                
                $('#cleardata').click(function(){
                    $server.data('server').deleteDataBase();
                    alert('Données effacées'); 
                });
                
                goToApplication = function(user_id){
                    getData(parseInt(user_id));//Récupération des données
                    $playlistsContainer.show();
                    $playerContainer.show();
                    $('.signin').hide();

                    //WEBSOCKET
                    var ws = new WebSocket("ws://btn.d-connect.fr:8100");
                    var canvas;
                    var context;
                    var image = new Image();

                    window.onload=function() {

                    };

                    function dispMessage(audiofile) {
                        console.log('play message', audiofile);
                        $playerContainer.data('player').playAudioMessage(audiofile);
                    }

                    ws.onopen = function (event) {
                        ws.send('{ "type":"text", "content":"Browser ready.", "id":"pc", "user_id":'+user_id+'}' ); 
                    };

                    ws.onmessage = function (e) {
                        dispMessage(e.data);
                    };

                    //FIN WEBSOCKET	
                };
                
                $('#loginform').submit(function(event){
                    console.log('submit');
                    users = $server.data('server').checkUser($('#user_name').val(), $('#user_password').val());//verification de l'utilisateur
                    
                    users.then(function(users){
                        console.log('users CONNEXION', users);
                        if(users.length > 0 && typeof users[0].id !== 'undefined'){
                            console.log('Connected without internet');
                            goToApplication(users[0].id);
                        }else{
                            console.log('Connected with internet !');
                            $.ajax({
                                method: "POST",
                                url: "http://d-sound.fr/webservice/v1/connexion",
                                data: { 
                                    "user_name": $('#user_name').val(), 
                                    "user_password": $('#user_password').val() 
                                }
                            }).done(function( msg ) {           
                                $('.error-connexion').html('');
                                var obj = jQuery.parseJSON( msg );
                                console.log('MESG CONNEXION', obj);
                                if(typeof obj.user_id !== 'undefined' && obj.user_id){
                                    $server.data('server').insertUser(obj.user_id, $('#user_name').val(), $('#user_password').val());//Insertion de l'utilisateur
                                    goToApplication(obj.user_id);
                                }else{
                                   $('.error-connexion').html('Combinaison identifiant / mot de passe incorrect'); 
                                }
                            });
                        }
                        
                    });
                    
                    
                    event.preventDefault();
                });

            });
        </script>


    </body>
</html>